uses crt,soundlib;
type
  bytearray = array[0..32767] of byte;

const
  buffersize = 1024;

var
  f        : file;
  ch       : char;
  channels : byte;
  sound : array[0..31] of record
    p    : pointer;
    bp   : ^bytearray;
    size : word;
    play : boolean;
    pos  : word;
  end;
  playp : pointer;

procedure soundmixcaller;far;
var
  w,i : word;
  data       : ^bytearray;
  sample     : integer;
begin
  data := playp;
  for w := 0 to buffersize shr 1-1 do begin
    sample := 0;
    for i := 0 to channels-1 do with sound[i] do if play then begin
      inc(sample,bp^[pos]-127);
      inc(pos);
      if pos = size then play := false;
    end;
    data^[w+(buffersize shr 1)*(play.activeblock-1)] := sample div channels+127;
  end;
  if play.activeblock = 1 then play.activeblock := 2 else play.activeblock := 1;
end;


procedure loadraw(name : string);
begin
  assign(f,name);
  reset(f,1);
  sound[channels].size := filesize(f);
  getmem(sound[channels].p,sound[channels].size);
  sound[channels].bp := sound[channels].p;
  blockread(f,sound[channels].p^,sound[channels].size);
  close(f);
  inc(channels);
end;

begin
  if initblaster <> 0 then exit;
  loadraw('horn.raw');
  loadraw('scream.raw');
  loadraw('pfft.raw');
  loadraw('platsch.raw');
  setmemsize(buffersize);
  {$IFDEF DPMI}
  playp := ptr(play.p,0);
  {$ELSE}
  playp := play.p;
  {$ENDIF}

  fillchar(playp^,buffersize,127);
  play.callproc := soundmixcaller;
  initplay(0,play.p,buffersize,22050,snd_8bit+snd_mono+snd_nonsigned);
  writeln('Press buttons 1..4');
  repeat
    ch := readkey;
    case ch of
      '1' : begin;sound[0].pos := 0;sound[0].play := true;end;
      '2' : begin;sound[1].pos := 0;sound[1].play := true;end;
      '3' : begin;sound[2].pos := 0;sound[2].play := true;end;
      '4' : begin;sound[3].pos := 0;sound[3].play := true;end;
    end;
  until ch = #27;
  exitplay;
end.





