{$IFNDEF VER60}
{$A+,B+,F-,G+,I-,O+,P+,Q-,R-,S-,T-,V-,X+,Y-}
{$ELSE}
{ Uh.... not enough money for BP7? }
{$A+,B+,F-,G+,I-,O+,R-,S-,V-,X+}
{$ENDIF}
(****************************************************************************
 * Author           : Stefan Goehler, Germany                               *
 * Version          : 1.16                                                  *
 * Task             : Play and record with soundblaster and compatibles     *
 * You can use my units entirely in your own programs. Ripping any code off *
 * is not allowed without my permission. If you wanna use this unit in      *
 * commercial products, I mean if you wanna get ANY money or other for      *
 * software based on one of my units, you'll have to contact me - we'll     *
 * find a way.                                                              *
 *******                                                                    *
 * If there are any bugs, please email me!                                  *
 * If you don't know where the bug is, tell me what happened and also give  *
 * me your machine configuration. BTW, I am not responsible for any problems*
 * with non- Creative soundcards! Even if there is written, the card is 100%*
 * SB-compatible. If you have a problem on a non-SB, then you see that it   *
 * is not 100% compatible! Please don't bother me with such things then!    *
 *                                                                          *
 * my homepage: http://sourcenet.home.pages.de                              *
 * ^^^note that you can get there always the actual version of this unit    *
 * if you have additions, tips or sth. else, mail to stefan.goehler@gmx.de  *
 ****** KNOWN PROBLEMS ******************************************************
 * . The program is not able to play any compressed files.                  *
 * . Soundlib will only play the first chunk of multi-chunked files         *
 ****** HISTORY *************************************************************
 * History                                                                  *
 * Version 1.0 : .first public available Version                            *
 *                (4th Sep. 1997)                                           *
 * Version 1.01: *fixed a bug with multifiles- LASTONE wasn't setted back   *
 *                and the sb played not without reseta 16bit-file after a   *
 *                8bit file correctly                                       *
 *               +added some additional in the readme                       *
 *                (6th Sep. 1997)                                           *
 * Version 1.1   -removed needless things                                   *
 *               +added surround sound                                      *
 *               *fixed a bug when playback runs, that you can't open a file*
 *               +added function getactpos- gives back the fileremain minus *
 *                the already played sounddata - very accurate              *
 *               -removed LASTONE and used a better method                  *
 *               *fixed bug that the file won't play to the full end        *
 *                (9th Sep. 1997)                                           *
 * Version 1.11  *fixed a bug which won't set the speaker on with older     *
 *                version of soundblasters                                  *
 *               *soundlib is now runable under TP6 without any changes     *
 * Version 1.12  *changed 'pitch' to 'treble'                               *
 *               *fixed a little bug that causes terrible sounds with some  *
 *                files smaller than the doublebuffer                       *
 *               *changed line to linein because of conflicts with linedraw *
 * Version 1.13  *changed wave-loader in that way it can also read wav-files*
 *                with additional chunks (like program, copyright...etc)    *
 *                (31st March 1998)                                         *
 * Version 1.14  +new procedure getblasterstring - get name of the SB       *
 *               *procedure errorproc is a variable - so if you have a gui  *
 *                you are able to make a workaround for the textmode        *
 *                error-messages                                            *
 *               *voc-loader should now load nearly all vocs                *
 *               +Protected mode support                                    *
 *               *improved error-checking in procedure initblaster          *
 *               *downsample-handling improved                              *
 *               *removed some detail bugs                                  *
 *                (18th July 1998)                                          *
 * Version 1.15  +SB Pro 2.0 support added                                  *
 *               *fixed small bug in dmagetpos                              *
 *               +made setagc public (why did I forget that???)             *
 *               *fixed bug that the player doesn't play the last block     *
 *                (9th November 1998)                                       *
 * Version 1.2   *fixed bug which caused nasty clicking, if wave file       *
 *                contained additional data at the end                      *
 *               *fixed problem concerning the SBLive! SB16 emulator, which *
 *                caused the detection routine to say the soundcard is busy *
 *               *far better sounding stereo to mono downsampling           *
 *               *SB Live! detection included (I hope only this one has     *
 *                DSP version $40D), plus its support for 48 Khz            *
 ****** FUTURE EXTENSIONS ***************************************************
 * .ADPCM decoder                                                           *
 * .variable samplerate converter                                           *
 ****************************************************************************)
{Bugs:
 - Probleme bei kleinen Files und downsampling
 - bei downsamping mit SBpro ab 2. Block nur halbe samplingrate}

unit soundlib;
interface
uses
{$IFNDEF DPMI}
  dos;
{$ELSE}
  dos,winapi;
{$ENDIF}

type
{$IFDEF DPMI}
  tmemp = longint;
{$ELSE}
  tmemp = pointer;
{$ENDIF}
  tplay = record
    hispeed    : boolean;{ SbPro internal usage }

    blocksize  : longint;{ half size of the getted buffermemory            }
    p          : tmemp;  { pointer to the sounddata buffermemory           }
    activeblock: byte;   { active bufferblock (because of doublebuffering) }
    callproc   : procedure;{ the procedure to call with the interrupt      }

    stopped    : boolean;  { the playback is stopped     }
    paused     : boolean;  { playback is paused          }

    data : array[0..19] of record
      frequency  : longint;{ samplingrate                }
      stereo     : boolean;{ file is stereo              }
      sound16bit : boolean;{ file has 16 bit data        }

      format     : word;   { see format constants        }
      blockalign : word;   { How we can seek in the file }
      signed     : boolean;{ sounddata is signed         }

      fileremain : longint;{ remain of the file to play                 }
      fdatasize  : longint;{ size of the real data in the file          }
      fsize      : longint;{ size of the file to play                   }
      fdatastart : longint;{ startposition of the sounddata in the file }
      f          : file;   { file to read/write                         }
      fclosed    : boolean;{ shows if the file is open or not           }
    end;
  end;

  trec = record
    hispeed    : boolean; { SbPro internal usage }

    blocksize   : longint;{ half size of the getted buffermemory       }
    p           : tmemp;  { pointer to the sounddata buffermemory      }
    activeblock : byte;   { active bufferblock (doublebuffering)       }
    callproc    : procedure;{the procedure to call with the interrupt  }

    stopped     : boolean;{ the recording is stopped                   }
    paused      : boolean;{ recording is paused                        }

    frequency   : longint;{ samplingrate                               }
    stereo      : boolean;{ is recorded in stereo                      }
    sound16bit  : boolean;{ is recorded in 16 bit                      }
    format      : word;   { see format constants                       }
    signed      : boolean;{ is sounddata signed                        }

    fileremain  : longint;{ remain of the file to play                 }
    fdatasize   : longint;
    fsize       : longint;{ size of the file to play                   }
    fdatastart  : longint;{ startposition of the sounddata in the file }
    f           : file;   { file to read/write                         }
    fclosed     : boolean;{ shows if the file is open or not           }
  end;

const
  sblive             = $40D;
  sb16               = $400;
  sbpro20            = $301;
  sbpro              = $300;
  sb21               = $210;
  sb20               = $200;
  actfile            : byte = 0;{ the momently used file }

  { Constants for the dma-port-adresses }
  dma_lpage          : array[0..7] of byte = ($87,$83,$81,$82,$88,$8B,$89,$8A);
  dma_hpage          : array[0..7] of word = ($487,$483,$481,$482,$00,$48B,$489,$48A);
  dma_adr            : array[0..7] of byte = ($00,$02,$04,$06,$C0,$C4,$C8,$CC);
  dma_wc             : array[0..7] of byte = ($01,$03,$05,$07,$C2,$C6,$CA,$CE);

  snd_mono      = 0;
  snd_8bit      = 0;
  snd_nonsigned = 0;
  snd_stereo    = 1;
  snd_16bit     = 2;
  snd_signed    = 4;

  off = false;
  on  = true;

  { Constants for volume settings }
  master    = 1;
  voice     = 2;
  midi      = 3;
  cd        = 4;
  linein    = 5;
  mike      = 6;
  speaker   = 7;
  treble    = 8;
  bass      = 9;
  snd_left  = 1;
  snd_right = 2;

  { Constants for WAVe format types }
  fmt_unknown  = $0000;
  fmt_pcm      = $0001;
  fmt_msadpcm  = $0002;
  fmt_imaadpcm = $0011;

  buffersize  : word = 16104;  { Largest legal buffer value      }
  autorestore : boolean = true;{ automatic restore mixersettings }
  surround    : boolean = false;
  sb_errorstr : array[0..8] of string=('No error',
                                       'No soundcard found',
                                       'Soundard not supported',
                                       'Soundcard busy',
                                       'File not found',
                                       'Compressed files not supported',
                                       'Format not supported',
                                       'File handle not valid',
                                       'Soundcard interrupt doesn''t respond');
  sb_noerror      = 0;
  sb_nocardfound  = 1;
  sb_notsupported = 2;
  sb_busy         = 3;
  sb_filenotfound = 4;
  sb_nocompressed = 5;
  sb_falseformat  = 6;
  sb_nohandles    = 7;
  sb_nointrespond = 8;

  soundlib_vstr = 'SoundLib 1.2';
  soundlib_vnum = $0120;

var
  oldexitproc     : pointer;

  blaster          : record
    irq         : byte;
    lodma,hidma : word;
    adress      : word;
    aweport     : word; { not really used by unit }
    version     : word;
    available   : boolean;
    {following will be filled with the maximum playback values}
    minfreq     : longint;
    monofreq,
    stereofreq  : longint;
    sound16bit  : boolean;
    stereo      : boolean;
  end;

  play             : tplay;
  rec              : trec;
  dummy            : word;

  oldint           : pointer;
  irqmsk,irqvec    : byte;
  dsbuf            : pointer; { Buffer for downsampling }

  function  initblaster : byte;{call it _before_ any usage of the blaster}
  function  getblasterstring : string;
  procedure initrecord(p : tmemp;buffersize,frequency : word;flags : word);
  procedure initplay(datanum: byte;p : tmemp;buffersize,frequency : word;flags : word);
  procedure exitplay;{stop playback - use it only if you haven't used open****}
  procedure exitrecord;
  procedure pauserecord(pause : boolean);
  procedure pauseplay(pause : boolean);
  procedure startplay(datanum : byte);{start playback if you used open****}
  procedure stopplay; {stop  playback if you used open****}
  function  getactpos : longint;
  procedure silence(var p; count : word);
  procedure setplaypos(datanum : byte;pos : longint);{set fileposition of playback file - only if you used open****}
  function  setagc(on : boolean) : boolean;
  function  setvolume(what,left,right : byte) : boolean;
  function  getvolume(what : byte;var left,right : byte) : boolean;
  function  setoutput(output : byte;left,right : boolean) : boolean;
  function  setinput(input,channel : byte;left,right : boolean) : boolean;
  function  getinput(input,channel : byte;var left,right : boolean) : boolean;
  function  setgain(out : boolean;left,right : byte) : boolean;
  function  getgain(out : boolean;var left,right : byte) : boolean;
  function  setmemsize(size : word) : boolean;
  function  openvoc(datanum : byte;filename : string) : byte;
  function  openwav(datanum : byte;filename : string) : byte;
  function  opensound(datanum : byte;s : string) : byte;{open wave or vocfile -the program detects that with file extension}
  procedure closesound(datanum : byte);{close playback file and stop playback}
  procedure savemixer;
  procedure restoremixer;
  procedure error(num : byte);
var
  detectblaster : function : boolean;

const
  errorproc : procedure(num : byte) = error;
  {Change this if you have i.e. a GUI}

implementation

  function  readmixer(reg: byte) : byte;forward;
  procedure writemixer(reg, val: byte);forward;

procedure error(num : byte);
begin
  asm mov ax,3;int 10h end;
  writeln('Error: ',sb_errorstr[num]);
  halt;
end;

function getblasterstring : string;
begin
  with blaster do begin
    if version >= sblive then
      getblasterstring := 'Soundblaster Live!' else
    if version >= sb16 then begin
      if aweport = 0 then
      getblasterstring := 'Soundblaster 16' else
      getblasterstring := 'Soundblaster AWE32/64'
    end else
    if version >= sbpro20 then
    getblasterstring := 'Soundblaster Pro 2.0' else
    if version >= sbpro then
    getblasterstring := 'Soundblaster Pro' else
    if version >= sb21 then
    getblasterstring := 'Soundblaster 2.1' else
    if version >= sb20 then
    getblasterstring := 'Soundblaster 2.0';
  end;
end;

procedure writedsp(v : byte);assembler;
asm
  mov   dx,blaster.adress
  add   dx,0Ch
  xor   cx,cx
  @lp:
    in    al,dx
    dec   cx
  jz    @err
  cmp   al,127
  ja    @lp
  jmp   @noerr
  @err:
    push  sb_busy
    call  errorproc
  @noerr:
  mov   al,v
  out   dx,al
end;

var
  endtime : longint;

function currenttime : longint;assembler;
asm
  {$IFDEF VER60}
  mov   ax,$0040;
  mov   es,ax
  {$ELSE}
  mov   es,[seg0040]
  {$ENDIF}
  mov   ax,es:[6Ch]
  mov   dx,es:[6Eh]
end;

function resetblaster : boolean;
var
  b : byte;
begin
  port[blaster.adress+$6] := 1;
  endtime := currenttime+3;
  while endtime > currenttime do;
  port[blaster.adress+$6] := 0;
  endtime := currenttime+2;
  repeat
    b := port[blaster.adress+$E];
    b := port[blaster.adress+$A];
  until (b = $AA)or(currenttime >= endtime);
  resetblaster := b = $AA;
end;

procedure resetblaster_fast;
begin
  port[blaster.adress+$6] := 1;
  port[blaster.adress+$6] := 0;
end;


procedure setspeed(hz : byte);assembler;
asm
  push   40h
  call   writedsp
  mov    al,hz
  dec    al
  push   ax
  call   writedsp
end;

procedure setspeedSB16play(hz : word);assembler;
asm
  push   42h
  call   writedsp
  mov    ax,hz
  mov    al,ah
  xor    ah,ah
  push   ax
  call   writedsp
  mov    ax,hz
  xor    ah,ah
  push   ax
  call   writedsp
end;

procedure setspeedSB16record(hz : word);assembler;
asm
  push   41h
  call   writedsp
  mov    ax,hz
  mov    al,ah
  xor    ah,ah
  push   ax
  call   writedsp
  mov    ax,hz
  xor    ah,ah
  push   ax
  call   writedsp
end;

procedure setsamplingrate(hz : word);
begin
  if blaster.version >= sb16 then setspeedSB16play(hz) else begin
    if blaster.version >= sbpro then
    setspeed(256-(1000000 div (longint(hz)*succ(byte(play.data[actfile].stereo)))))
    else setspeed(256-(1000000 div (longint(hz))));
    if hz < 36000 then begin {Lowpass filter for better sound quality}
      writemixer($0E,readmixer($0E) and not 32);
      if hz < 18000 then writemixer($0C,readmixer($0C) and not 8) {3,2 khz}
      else writemixer($0C,readmixer($0C) or 8); {8,8 khz-filter}
    end else writemixer($0E,readmixer($0E) or 32);
  end;
end;

procedure setsamplingraterec(hz : word);
begin
  if blaster.version >= sb16 then setspeedSB16record(hz) else
  setspeed(256-(1000000 div (longint(hz)*succ(byte(rec.stereo)))));
end;

procedure pauserecord(pause : boolean);
{Pause the recording - if you play at the same resolution
 (8 or 16 bit) as the recording, this procedure will pause
 both recording and playing}
begin
  if pause then begin
    if not rec.paused then if (rec.sound16bit)and(blaster.version >= sb16) then writedsp($D5) else writedsp($D0);
  end else begin
    if rec.paused then if (rec.sound16bit)and(blaster.version >= sb16) then writedsp($D6) else writedsp($D4);
  end;
  rec.paused := pause;
end;

procedure pauseplay(pause : boolean);
{Pause the playback - if you record at the same resolution
 (8 or 16 bit) as the playing, this procedure will pause
 both recording and playing}
begin
  if pause then begin
    if not play.paused then if (play.data[actfile].sound16bit)and(blaster.version>=sb16) then writedsp($D5) else writedsp($D0);
  end else begin
    if play.paused then if (play.data[actfile].sound16bit)and(blaster.version >= sb16) then writedsp($D6) else writedsp($D4);
  end;
  play.paused := pause;
end;


var
  settings1 : array[1..9] of record
    l,r : byte;
  end;
  settings2 : array[1..8] of byte;

procedure savemixer;
begin
  for dummy := 1 to 9 do getvolume(dummy,settings1[dummy].l,settings1[dummy].r);
  if blaster.version >= sb16 then
  for dummy := 1 to 8 do settings2[dummy] := readmixer($3B+dummy)
  else if blaster.version >= sbpro then begin
    settings2[1] := readmixer($0C);
    settings2[2] := readmixer($0E);
  end;
end;

procedure restoremixer;
begin
  for dummy := 1 to 9 do setvolume(dummy,settings1[dummy].l,settings1[dummy].r);
  if blaster.version >= sb16 then
  for dummy := 1 to 8 do writemixer($3B+dummy,settings2[dummy])
  else if blaster.version >= sbpro then begin
    writemixer($0C,settings2[1]);
    writemixer($0E,settings2[2]);
  end;
end;

procedure exitblaster;far;
begin
  exitproc := oldexitproc;
  if blaster.available then begin
    if not play.data[actfile].fclosed then closesound(actfile);
    if not rec.stopped then exitrecord;
    setintvec(irqvec+(blaster.irq and 7),oldint);
    if blaster.irq < 8 then
    port[$21] := port[$21] or irqmsk else port[$A1] := port[$A1] or irqmsk;
    writedsp($D3);
    if blaster.irq < 8 then port[$20] := $20 else port[$A0] := $20;
    if autorestore then restoremixer;
    {$IFNDEF DPMI}
    freemem(play.p,buffersize);
    {$ELSE}
    globaldosfree(play.p);
    {$ENDIF}
    freemem(dsbuf,buffersize*4);
  end;
end;

procedure initdma(dma : byte;p : tmemp;size : word;get,autoinit : boolean);
var
  b : byte;
  l : longint;
  segm,offs : word;
begin
  {$IFNDEF DPMI}
  l := longint(seg(p^)) shl 4+ofs(p^);
  {$ELSE}
  p := p and $FFFF0000;
  l := ((p and $FFFF0000) shr 16) shl 4+p and $FFFF;
  {$ENDIF}
  segm := l shr 16;
  if dma > 3 then
  offs := word((longint(p) and $FFFF0000) shr 13+(longint(p) and $FFFF) shr 1)
  else
  offs := l and $FFFF;

  if get then b := $44 else b := $48;
  if autoinit then inc(b,$10);

  if dma > 3 then begin
    port[$D4] := dma;
    port[$D6] := b+dma-4;
    port[$D8] := 0;
  end else begin
    port[$0A] := dma+4;
    port[$0B] := b+dma;
    port[$0C] := 0;
  end;
  port[dma_adr[dma]] := Lo(offs);
  port[dma_adr[dma]] := Hi(offs);
  port[dma_lpage[dma]] := segm;
  port[dma_wc[dma]] := Lo(size-1);
  port[dma_wc[dma]] := Hi(size-1);
  if dma > 3 then port[$D4] := dma-4 else port[$0A] := dma;
end;

function dmagetpos(dma : byte) : word;
var
  w : word;
begin
  if dma > 3 then
  port[$D8] := 0 else
  port[$0C] := 0;
  w := port[dma_wc[dma]];
  w := word(port[dma_wc[dma]]) shl 8+w;
  inc(w);
  if dma > 3 then w := w shl 1;
  dmagetpos := w;
end;

function getactpos : longint;
var
  dma : byte;
  l,l2: longint;
begin
  if (blaster.version >= sb16)and(play.data[actfile].sound16bit) then
  dma := blaster.hidma else dma := blaster.lodma;
  l := (play.data[actfile].fsize - play.data[actfile].fileremain)+
       (buffersize-dmagetpos(dma))- pred(play.activeblock)*play.blocksize-buffersize;
  l2 := play.data[actfile].fsize - play.data[actfile].fdatastart;
  if l > l2 then l := l2;
  getactpos := l;
end;

procedure playsb(p : tmemp;dsize : word);
begin
  initdma(blaster.lodma,p,dsize,false,false);
  writedsp($14);
  writedsp(Lo(dsize-1));
  writedsp(Hi(dsize-1));
end;

procedure initrecord(p : tmemp;buffersize,frequency : word;flags : word);
var
  size,dma : word;
begin
  if not blaster.available then exit;
  rec.sound16bit := flags and snd_16bit <> 0;
  rec.stereo     := flags and snd_stereo <> 0;
  rec.blocksize  := buffersize shr 1;
  rec.frequency  := frequency;
  rec.p          := p;
  rec.activeblock:= 2;{Block where the last data has been written to}
  rec.stopped    := false;
  rec.hispeed    := false;

  size := play.blocksize;

  setsamplingraterec(frequency);

  if blaster.version >= sb16 then begin
    size := rec.blocksize;
    if rec.sound16bit then begin
      size := size shr 1;
      dma := blaster.hidma;
    end else dma := blaster.lodma;

    initdma(dma,rec.p,size shl 1,true,true);
    if rec.sound16bit then begin
      writedsp($BE);
      if rec.stereo then writedsp($30) else writedsp($10);{signed!!!}
      end else begin
        writedsp($CE);
        if rec.stereo then writedsp($20) else writedsp($00);
      end;
      writedsp(Lo(size-1));
      writedsp(Hi(size-1));
    end else if
  ((blaster.version >= sb21)and((rec.frequency > 13000))or
  ((blaster.version >=sbpro)and((rec.frequency > 23000)or(rec.stereo)))) then begin
 {sb21 or higher and sr > 13000 or sbpro and sr > 23000}
    writedsp($D3);
    rec.hispeed := true;
    if (rec.stereo)and(blaster.version >= sbpro) then{sbpro and stereo and sr >= 11025 and sr <= 22050}
    writedsp($A8);

    initdma(blaster.lodma,rec.p,size shl 1,true,true);
    setsamplingrate(rec.frequency);

    writedsp($48);
    writedsp(Lo(size-1));
    writedsp(Hi(size-1));
    writedsp($98);
  end else begin {sb20 or higher, mono and sr <=13000}
    writedsp($D3);
    initdma(blaster.lodma,rec.p,size shl 1,true,true);
    setsamplingrate(rec.frequency);

    writedsp($48);
    writedsp(Lo(size-1));
    writedsp(Hi(size-1));
    writedsp($2C);
  end;
end;


procedure downsample8(p1,p2 : pointer;adder,size : word);far;assembler;
asm
  mov   cx,size
  or    cx,cx
  jz    @end
  push  ds
  les   di,p1
  lds   si,p2
  mov   bx,adder
  @lp:
    mov   ax,es:[di]

    mov   ds:[si],ax
    add   di,bx
    add   si,2
    dec   cx
  jnz   @lp
  pop   ds
  @end:
end;

procedure downsample8m(p1,p2 : pointer;adder,size : word);far;assembler;
asm
  mov   cx,size
  shl   cx,1
  jz    @end
  push  ds
  les   di,p1
  lds   si,p2
  mov   bx,adder
  shr   bx,1
  xor   dh,dh
  @lp:
    mov   ax,es:[di]
    mov   dl,ah
    xor   ah,ah
    add   ax,dx
    shr   ax,1

    mov   ds:[si],al
    add   di,bx
    inc   si
    dec   cx
  jnz   @lp
  pop   ds
  @end:
end;

procedure downsample16(p1,p2 : pointer;adder,size : word);far;assembler;
asm
  mov   cx,size
  or    cx,cx
  jz    @end
  push  ds
  mov   bx,adder
  les   di,p1
  lds   si,p2
  @lp:
    mov   al,es:[di+1]
    mov   ah,es:[di+3]
    add   al,$80
    add   ah,$80

    mov   ds:[si],ax
    add   di,bx
    add   si,2
    dec   cx
  jnz   @lp
  pop   ds
  @end:
end;

procedure downsample16m(p1,p2 : pointer;adder,size : word);far;assembler;
asm
  mov   cx,size
  shl   cx,1
  jz    @end
  push  ds
  mov   bx,adder
  shr   bx,1
  les   di,p1
  lds   si,p2
  @lp:
    mov   ah,es:[di+1]
    mov   dh,es:[di+3]
    sar   ax,8
    sar   dx,8
    add   ax,dx
    sar   ax,1
    add   al,$80

    mov   ds:[si],al
    add   di,bx
    inc   si
    dec   cx
  jnz   @lp
  pop   ds
  @end:
end;

procedure surround16(p : pointer;size : word);assembler;
asm
  mov   cx,size
  or    cx,cx
  jz    @end
  les   di,p
  @lp:
    mov   ax,es:[di]
    neg   ax
    mov   es:[di],ax
    add   di,4
    dec   cx
  jnz   @lp
  @end:
end;

procedure surround8(p : pointer;size : word);assembler;
asm
  mov   cx,size
  or    cx,cx
  jz    @end
  les   di,p
  @lp:
    mov   al,es:[di]
    neg   al
    mov   es:[di],al
    add   di,2
    dec   cx
  jnz   @lp
  @end:
end;


var
  dummycalled : boolean;

procedure dummycaller;far;
begin
  dummycalled := true;
end;


procedure exitplay;
begin
  if play.stopped then exit;
  if blaster.version >= sb16 then begin
    if play.data[actfile].sound16bit then writedsp($D9) else writedsp($DA);
    resetblaster_fast;
  end else if play.hispeed then begin
    resetblaster_fast;
    writedsp($D3);
    writemixer($E,readmixer($E) and not 2);
  end else begin
    writedsp($D3);
    writedsp($DA);
    resetblaster_fast;
  end;
  play.stopped  := true;
  play.callproc := dummycaller;
end;

procedure exitrecord;
begin
  if not rec.stopped then begin
    if blaster.version >= sb16 then begin
      if rec.sound16bit then writedsp($D9) else writedsp($DA);
      resetblaster;
    end else if rec.hispeed then begin
      resetblaster;
      writemixer($E,readmixer($E) and not 2);
    end else begin
      writedsp($DA);
      resetblaster;
    end;
    rec.stopped  := true;
    rec.callproc := dummycaller;
  end;
end;


procedure silence(var p; count : word);
 procedure fillword(var X; Count: Word; value : word);assembler;
 asm les di,x;mov cx,count;mov ax,value;rep stosw;end;
begin
  if (play.data[actfile].sound16bit)and(blaster.sound16bit) then fillword(p,count shr 1,0) else fillword(p,count shr 1,$8080);
end;

var
  dsjump : word;
  downsample : procedure(p1,p2 : pointer;adder,size : word);

function outofspec(freq : word;stereo,sound16bit : boolean) : boolean;
begin
  outofspec := true;
  if (longint(freq)*2 > blaster.monofreq)and(not blaster.stereo) then exit;
  if (stereo)and(not blaster.stereo) then exit;
  if (sound16bit)and(not blaster.sound16bit) then exit;
  if (stereo)and(freq > blaster.stereofreq) then exit;
  if (not stereo)and(freq > blaster.monofreq) then exit;
  outofspec := false;
end;

procedure read(var f : file;p : pointer;size,bsize : word);
var
  mem    : word;
  readen,io : word;
begin
{  writeln(size);}
  if (blaster.version < sb16) then begin
    if outofspec(play.data[actfile].frequency,play.data[actfile].stereo,
    play.data[actfile].sound16bit) then
    begin
      mem := size*(dsjump shr 1);
      {$I-}
      blockread(f,dsbuf^,mem,readen);
      {$I+}
      io := ioresult;
      downsample(dsbuf,p,dsjump,size shr 1);
      dec(play.data[actfile].fileremain,mem);
    end else begin
      blockread(f,p^,size,readen);
      dec(play.data[actfile].fileremain,size);
      if (play.data[actfile].stereo)and(surround)and(blaster.version >= sbpro) then
      surround8(p,size shr 1);
    end;
  end else begin
    {$I-}
    blockread(f,p^,size,readen);
    {$I+}
    io := ioresult;
    dec(play.data[actfile].fileremain,readen);
    if (play.data[actfile].stereo)and(surround)and(blaster.version >= sbpro) then begin
      if play.data[actfile].sound16bit then
      surround16(p,size shr 2) else
      surround8(p,size shr 1);
    end;
  end;
  if readen < bsize then silence(ptr(seg(p^),ofs(p^)+(readen and not 1))^,bsize-readen);
end;

var
  lastblock : boolean; { Crappy solution... but works ;) }

procedure soundplaycaller;far;
var
  p    : pointer;
  size : word;
begin
  if (play.data[actfile].fileremain > 0) then begin
    size := play.blocksize;
    if (size > play.data[actfile].fileremain) then size := play.data[actfile].fileremain;
    {$IFNDEF DPMI}
    read(play.data[actfile].f,ptr(seg(play.p^),ofs(play.p^)+play.blocksize*pred(play.activeblock)),size,play.blocksize);
    {$ELSE}
    read(play.data[actfile].f,ptr(play.p and $FFFF,play.blocksize*pred(play.activeblock)),size,play.blocksize);
    {$ENDIF}
    if play.activeblock = 2 then play.activeblock := 1 else play.activeblock := 2;
    lastblock := false;
  end else
  if not lastblock then lastblock := true else exitplay;
end;

var
  intrunning : boolean;

procedure intcaller;interrupt;
var
  h   : byte;
  run : boolean;
begin
  run := intrunning;
  intrunning := true;
  if blaster.version >= sb16 then begin
    h := readmixer($82);
    if h and 1 <> 0 then h := port[blaster.adress+$E] else h := port[blaster.adress+$F];
    if not run then begin{If interrupts overlap, the machine may hang!}
      if not rec.stopped then rec.callproc;
      if not play.stopped then play.callproc;
    end;
  end else begin
    h := port[blaster.adress+$E];
    if not run then begin{If interrupts overlap, the machine may hang!}
      if not play.stopped then play.callproc;
      if not rec.stopped then rec.callproc;
    end;
  end;
  if blaster.irq > 7 then
  port[$A0] := $20;
  port[$20] := $20;
  intrunning := false;
end;

function hex2word(s : string) : word;
const
  number : set of char=['0'..'9'];
var
  i    : word;
  w,w2 : word;
begin
  w := 0;
  for i := 1 to length(s) do begin
    if s[i] in number then
    w2 := ord(s[i])-48
    else
    w2 := ord(s[i])-55;
    inc(w,w2 shl ((length(s)-i)*4));
  end;
  hex2word := w;
end;

function getdspversion : word;assembler;
asm
 push   $E1
 call   writedsp
 mov    dx,blaster.adress
 add    dx,0Ah
 @lp1:
   in    al,dx
   cmp   al,$AA
   mov   ah,al
 je @lp1
 @lp2:
   in    al,dx
   cmp   al,$AA
 je @lp2
end;

function detectawe32(baseport : word) : boolean;
var
  scratch,tmp : word;
begin
  detectawe32 := false;
  portw[$0E02+baseport] := 224;
  tmp := portw[$0E00+baseport];
  scratch := portw[$0E00+baseport];
  if scratch and $000F <> $0C then exit;
  portw[$0E02+baseport]:= 32+29;
  scratch := portw[$0A00+baseport];
  if scratch and $007E <> $58 then exit;
  portw[$0E02+baseport] := 32+30;
  scratch := portw[$0A00+baseport];
  if scratch and $0003 <> $03 then exit;
  detectawe32 := true;
end;

function detectblaster_norm : boolean;far;
var
  s,s2 : string;
  i    : word;
  i2   : integer;
begin
  detectblaster_norm := false;
  s := getenv('BLASTER');
  if s = '' then exit;              {No blaster environment string...}
  for i := 1 to length(s)
  do s[i] := upcase(s[i]);

  i := pos('D',s);
  if i <> 0 then begin
    val(s[i+1],i,i2);
    blaster.lodma := i;
  end else exit;
  i := pos('H',s);
  if i <> 0 then begin
    val(s[i+1],i,i2);
    blaster.hidma := i;
  end else blaster.version := sbpro;

  i := pos('I',s);
  if i <> 0 then begin
    val(s[i+1],i,i2);
    blaster.irq := i;
    i := pos('I',s);
    if (i+2 <= length(s))and(s[i+2] <> ' ') then begin
      blaster.irq := blaster.irq*10;
      val(s[i+2],i,i2);
      inc(blaster.irq,i);
    end;
  end else exit;

  i := pos('A',s);
  if i <> 0 then begin
    for i2 := 1 to 3 do s2[i2] := s[i+i2];
    s2[0] := #3;
    s2[4] := #0;
    blaster.adress := hex2word(s2);
  end else exit;

  detectblaster_norm := true;
end;

(*function detectblaster_auto : boolean;far;
{I suggest to not use this, I was simply to lazy
 to improve the routine yet...                  }
var
  i : integer;
  temp1,temp2,pic1,pic2,x : byte;
begin
  detectblaster_auto := false;
  blaster.adress := $200;
  for i := 0 to 8 do begin
    if not resetblaster then
    inc(blaster.adress,$10) else break;
  end;
  if blaster.adress = $290 then begin
    blaster.adress := 0;
    exit;
  end;

  temp1 := port[$21];
  temp2 := port[$A1];
  port[$21] := temp1 or $A4;
  port[$A1] := temp2 or 4;
  writedsp($40);
  writedsp($D2);
  writedsp($80); { silent block }
  writedsp(1);
  writedsp(0);

  port[$20] := $A;
  port[$A0] := $A;
  pic1 := 0;
  pic2 := 0;
  i := 0;
  endtime := currenttime+18;
  repeat
    pic1 := port[$20] and $A0;
    pic2 := port[$A0] and $6;
  until ((pic1 <> 0)or(pic2 <> 0))or(endtime <= currenttime);

  i := port[blaster.adress+$0E];
  if (pic1 = 0)and(pic2 = 0) then begin
    blaster.irq := 0;
    exit;
  end;
  port[$21] := temp1;
  port[$A1] := temp2;
  blaster.irq := 0;
  if pic2 <> 0 then begin
    blaster.irq := 7;
    while pic2 and 1 = 0 do begin
      inc(blaster.irq);
      pic2 := pic2 shr 1;
    end;
  end else
  while pic1 and 1 = 0 do begin
    inc(blaster.irq);
    pic1 := pic1 shr 1;
  end;

  writedsp($D3);
  writedsp($D0);
  writedsp($DA);
  resetblaster;

  port[$F] := $FF;
  writedsp($40);
  writedsp($D2);
  writedsp($14); { single block/dma }
  writedsp(1);
  writedsp(0);
  endtime := currenttime+18;
  repeat
    x := port[8] and $F0;
  until (x <> 0)or(endtime <= currenttime);
  blaster.lodma := 0;
  if x = 0 then exit;
  x := x shr 4;
  while x and 1 = 0 do begin
    inc(blaster.lodma);
    x := x shr 1;
  end;

  writedsp($D3);
  writedsp($D0);
  writedsp($DA);
  resetblaster;


{  blaster.irq := 7;}
{  blaster.lodma := 1;}
  blaster.hidma := 5;
  detectblaster_auto := true;
end;*)

function initblaster : byte;
var
  i      : integer;
  p,oldp : tmemp;
begin
  if blaster.available then begin
    initblaster := sb_noerror;
    exit;
  end else initblaster := sb_nocardfound;
  blaster.version := 0;

  if not detectblaster then exit;

  if not resetblaster then begin { if blaster could not be resetted, }
     initblaster := sb_busy;     { it must be busy                   }
     exit;
  end;
  i := getdspversion;
  if blaster.version = 0 then blaster.version := i else
  if blaster.version < sb16 then blaster.version := i;
  {for any tests with lower blaster versions, change here the version}
{  blaster.version := sbpro;}
  if blaster.version < sb20 then begin        {blasters lower than version }
    initblaster := sb_notsupported;           {2.0 aren't supported because}
    exit;                                     {they cannot run the autoinit}
  end;                                        {mode - quality is too low   }

  with blaster do begin
    if version >= sblive then begin
      minfreq    := 5000;
      monofreq   := 48000;
      stereofreq := 48000;
      sound16bit := true;
      stereo     := true;
      aweport    := 0;
    end else
    if version >= sb16 then begin
      minfreq    := 5000;
      monofreq   := 45000;
      stereofreq := 45000;
      sound16bit := true;
      stereo     := true;
      aweport    := 0;
      for i := 0 to 4 do if
      detectawe32(i*$20) then aweport := $600+i*$20;
    end else if version >= sbpro20 then begin
      minfreq    := 4000;
      monofreq   := 44100;
      stereofreq := 44100;
      sound16bit := false;
      stereo     := true;
    end else if version >= sbpro then begin
      minfreq    := 4000;
      monofreq   := 44100;
      stereofreq := 22050;
      sound16bit := false;
      stereo     := true;
    end else if version >= sb21 then begin
      minfreq    := 4000;
      monofreq   := 44100;
      stereofreq := 0;
      sound16bit := false;
      stereo     := false;
    end else begin
      minfreq    := 4000;
      monofreq   := 23000;
      stereofreq := 0;
      sound16bit:= false;
      stereo    := false;
    end;
  end;
  if blaster.irq < 8 then
  irqvec := $8 else irqvec := $70;
  getintvec(irqvec+(blaster.irq and 7),oldint);
  setintvec(irqvec+(blaster.irq and 7),@intcaller);
  irqmsk := 1 shl (blaster.irq and 7);
  if blaster.irq < 8 then
  port[$21] := port[$21] and not irqmsk else
  port[$A1] := port[$A1] and not irqmsk;
  blaster.available:= true;
  {Test if SB works}
  dummycalled   := false;
  play.callproc := dummycaller;

  {$IFNDEF DPMI}
  getmem(p,$100);
  fillchar(p^,$100,$80);
  {$ELSE}
  p := globaldosalloc($100);
  fillchar(ptr(p,0)^,$100,$7F);
  {$ENDIF}
  oldp := play.p;
  initplay(0,p,$100,22050,snd_8bit+snd_mono+snd_nonsigned);
  endtime := currenttime+5;
  while (not dummycalled)and(currenttime < endtime) do;
  if not dummycalled then begin
    initblaster := sb_nointrespond;
    blaster.available := false;
    {$IFNDEF DPMI}
    freemem(p,$100);
    {$ELSE}
    globaldosfree(p);
    {$ENDIF}
    play.p := oldp;
    exit;
  end;
  resetblaster;
  {$IFNDEF DPMI}
  freemem(p,$100);
  {$ELSE}
  globaldosfree(p);
  {$ENDIF}
  exitplay;
  play.p := oldp;
(*  dummycalled   := false;
  play.callproc := dummycaller;
  play.stopped  := false;
  writedsp($40);
  writedsp($D2);
  writedsp($80); { silent block }
  writedsp(1);
  writedsp(0);
  endtime := currenttime+4;
  while (not dummycalled)and(currenttime < endtime) do;
  if not dummycalled then begin
     initblaster := sb_busy;
     exit;
  end;
  resetblaster;*)

  {end of test}
  play.stopped     := true;
  initblaster      := sb_noerror;
  savemixer;{save mixer settings}
end;



procedure writemixer(Reg, Val: byte);assembler;
asm
  mov   dx,blaster.adress
  add   dx,04h
  mov   al,reg
  out   dx,al
  inc   dx
  mov   al,val
  out   dx,al
end;

function readmixer(Reg: byte) : byte;assembler;
asm
  mov   dx,blaster.adress
  add   dx,04h
  mov   al,reg
  out   dx,al
  inc   dx
  in    al,dx
end;

function setagc(on : boolean) : boolean;
begin
  setagc := false;
  if blaster.version < sb16 then exit else setagc := true;
  writemixer($43,readmixer($43) or byte(on));
end;

function setoutput(output : byte;left,right : boolean) : boolean;
procedure setbit(bit : byte;on : boolean);
begin
  if on then
  writemixer($3C,readmixer($3C) or 1 shl bit) else
  writemixer($3C,readmixer($3C) and not (1 shl bit));
end;

begin
  setoutput := false;
  if blaster.version < sb16 then exit;
  case output of
    mike : setbit(0,left);
    cd   : begin;setbit(1,right);setbit(2,left);end;
    linein : begin;setbit(3,right);setbit(4,left);end;
    else exit;
  end;
  setoutput := true;
end;

function setinput(input,channel : byte;left,right : boolean) : boolean;
{How to use this function?
 -channel is 1 for left, 2 for right
 -you can switch the input for left _and_ right for one channel
 -if you record mono, the left configuration will be used -
  so if you wanna record both left and right in mono, switch
  channel 1(left) to left and right
 -if the blaster is sbpro - you can't set anything off -
  only one thing on with the call you will set the called input on}
procedure setbit(reg,bit : byte;left,right : boolean);
begin
  if bit = 0 then right := left;
  if right then
  writemixer(reg,readmixer(reg) or 1 shl bit) else
  writemixer(reg,readmixer(reg) and not (1 shl bit));

  if bit > 0 then
  if left then
  writemixer(reg,readmixer(reg) or 1 shl succ(bit)) else
  writemixer(reg,readmixer(reg) and not (1 shl succ(bit)));
end;

var
  b : byte;
begin
  setinput := false;
  if blaster.version >= sb16 then begin
    b := channel+$3C;
    case input of
      mike : setbit(b,0,left,false);
      cd   : setbit(b,1,left,right);
      linein : setbit(b,3,left,right);
      midi : setbit(b,5,left,right);
      else exit;
    end;
  end else if (blaster.version >= sbpro)and((left)or(right)) then begin
    case input of
      cd   : b := 1;
      mike : b := 2;
      linein : b := 3;
      else exit;
    end;
    writemixer($0C,readmixer($0C) or (b shl 1));
  end else exit;
  setinput := true;
end;

function getinput(input,channel : byte;var left,right : boolean) : boolean;
procedure getbit(reg,bit : byte;var left,right : boolean);
begin
  byte(right) := (readmixer(reg) and (1 shl bit)) shr bit;
  if bit > 0 then
  byte(left) := (readmixer(reg) and (1 shl succ(bit))) shr succ(bit);
  if bit = 0 then left := right;
end;

var
  b,b2 : byte;

begin
  getinput := false;
  if blaster.version >= sb16 then begin
    b := channel+$3C;
    case input of
      mike : getbit(b,0,left,right);
      cd   : getbit(b,1,left,right);
      linein : getbit(b,3,left,right);
      midi : getbit(b,5,left,right);
      else exit;
    end;
  end else if blaster.version >= sbpro then begin
    b2 := readmixer($0C) shr 1 and 3;
    case input of
      cd   : b := 1;
      mike : b := 2;
      linein : b := 3;
      else exit;
    end;
    left := b2 = b;
  end else exit;
  getinput := true;
end;


function setgain(out : boolean;left,right : byte) : boolean;
{This function controls the amplify of the sb16
 set out to true if you want to amplify the output
 else for the input set it false.
 The maximum size for left and right is 3!}
var
  b : byte;
begin
  setgain := false;
  if blaster.version >= sb16 then begin
    if out then b := $41 else b := $3F;
    writemixer(b,left shl 6);
    writemixer(b+1,right shl 6);
    setgain := true;
  end;
end;

function getgain(out : boolean;var left,right : byte) : boolean;
var
  b : byte;
begin
  getgain := false;
  if blaster.version >= sb16 then begin
    if out then b := $41 else b := $3F;
    left := readmixer(b) shr 6;
    right:= readmixer(b+1) shr 6;
    getgain := true;
  end;
end;

function setvolume(what,left,right : byte) : boolean;
{Maximum for left and right is 63. I know that this
 resolution is higher as the res of the sb. This
 is only for future versions of the sb - you have
 not to reprogram all things for volume settings!
 If the playback is mono, then the left volume will
 be used. The procedure returns false if the volume
 couldn't be setted (the soundcard doesn't support
 this volume type then)}
procedure setvol(reg,left,right : byte);
begin
  if blaster.version >= sb16 then begin
    writemixer(reg,left);
    if (reg <> $3A)and(reg <> $3B) then writemixer(reg+1,right);
  end else if blaster.version >= sbpro then begin
    writemixer(reg,left shl 4 or right);
  end else begin
    if (reg = $0A)or(reg = $0B) then left := left shr 1;
    writemixer(reg,left);
  end;
end;

begin
  if left  > 63 then left  := 63;
  if right > 63 then right := 63;
  left  := left  shr 1;
  right := right shr 1;
  setvolume := true;
  if blaster.version >= sb16 then begin
    left  := left  shl 3;
    right := right shl 3;
    case what of
      master  : setvol($30,left,right);
      voice   : setvol($32,left,right);
      midi    : setvol($34,left,right);
      cd      : setvol($36,left,right);
      linein  : setvol($38,left,right);
      mike    : setvol($3A,left,0);
      speaker : setvol($3B,left,0);
      treble  : setvol($44,left,right);
      bass    : setvol($46,left,right);
      else setvolume := false;
    end;
  end else if blaster.version >= sbpro then begin
    left  := left  shr 1;
    right := right shr 1;
    case what of
      master  : setvol($22,left,right);
      voice   : setvol($04,left,right);
      midi    : setvol($26,left,right);
      cd      : setvol($28,left,right);
      linein  : setvol($2E,left,right);
      else setvolume := false;
    end;
  end else begin
    left  := left shr 2;
    case what of
      master  : setvol($02,left,0);
      voice   : setvol($0A,left,0);
      midi    : setvol($06,left,0);
      cd      : setvol($08,left,0);
      else setvolume := false;
    end;
  end;
end;


function getvolume(what : byte;var left,right : byte) : boolean;
procedure getvol(reg : byte;var left,right : byte);
begin
  if blaster.version >= sb16 then begin
  left := readmixer(reg);
  if (reg <> $3A)and(reg <> $3B) then right := readmixer(reg+1) else right := left;
  end else if blaster.version >= sbpro then begin
    left  := readmixer(reg);
    right := left and $0F;
    left  := left shr 4;
  end else
  left := readmixer(reg);
  if reg = $0A then left := left shr 1;
end;

begin
  getvolume := true;
  if blaster.version >= sb16 then begin
    case what of
      master  : getvol($30,left,right);
      voice   : getvol($32,left,right);
      midi    : getvol($34,left,right);
      cd      : getvol($36,left,right);
      linein  : getvol($38,left,right);
      mike    : getvol($3A,left,right);
      speaker : getvol($3B,left,right);
      treble  : getvol($44,left,right);
      bass    : getvol($46,left,right);
      else getvolume := false;
    end;
    left  := left  shr 2;
    right := right shr 2;
  end else if blaster.version >= sbpro then begin
    case what of
      master  : getvol($22,left,right);
      voice   : getvol($04,left,right);
      midi    : getvol($26,left,right);
      cd      : getvol($28,left,right);
      linein  : getvol($2E,left,right);
      else getvolume := false;
    end;
    left  := left  shl 2;
    right := right shl 2;
  end else begin
    case what of
      master  : getvol($02,left,right);
      voice   : getvol($0A,left,right);
      midi    : getvol($06,left,right);
      cd      : getvol($08,left,right);
      else getvolume := false;
    end;
    left  := left shl 3;
    right := left;
  end;
end;


procedure initplay(datanum : byte;p : tmemp;buffersize,frequency : word;flags : word);
var
  size,dma     : word;
  savecallproc : procedure;
begin
  if not blaster.available then exit;
  play.data[datanum].sound16bit := flags and snd_16bit <> 0;
  play.data[datanum].stereo     := flags and snd_stereo <> 0;
  play.blocksize  := buffersize shr 1;
  play.data[datanum].frequency  := frequency;
  play.p          := p;
  play.activeblock:= 1;
  play.stopped    := false;
  play.hispeed    := false;

  size := play.blocksize;
  if blaster.version >= sb16 then begin
    setsamplingrate(play.data[datanum].frequency);

    if play.data[datanum].sound16bit then begin
      size := size shr 1;
      dma := blaster.hidma;
    end else dma := blaster.lodma;

    initdma(dma,play.p,size shl 1,false,true);
    if play.data[datanum].sound16bit then writedsp($B6)
    else writedsp($C6);
    if play.data[datanum].signed then begin
      if play.data[datanum].stereo then writedsp($30) else writedsp($10) end
      else begin if play.data[datanum].stereo then writedsp($20) else writedsp($00);end;
      writedsp(Lo(size-1));
      writedsp(Hi(size-1));
    end else if (blaster.version >= sb21)and((play.data[datanum].frequency > 23000)
    or(play.data[datanum].stereo)) then begin{sb21 or higher and sr > 23000}
    writedsp($D1);
    play.hispeed := true;
    if (play.data[datanum].stereo)and(blaster.version >= sbpro) then begin{sbpro and stereo and sr >= 11025 and sr <= 22050}
      {This part switches the sbpro to stereo mode
       This should work according to the manual from
       creative labs}
      writemixer($E,readmixer($E) or 2);
      savecallproc  := play.callproc;
      dummycalled   := false;
      play.callproc := dummycaller;
      {$IFNDEF DPMI}
      dummy := $80;
      playsb(@dummy,1);
      {$ELSE}
       mem[play.p and $FFFF:0] := $80;
       playsb(play.p,1);
      {$ENDIF}
      repeat until dummycalled;
      play.callproc := savecallproc;
    end;

    initdma(blaster.lodma,play.p,size shl 1,false,true);
    setsamplingrate(play.data[datanum].frequency);

    writedsp($48);
    writedsp(Lo(size-1));
    writedsp(Hi(size-1));
    writedsp($90);
  end else begin {sb20 or higher, mono and sr <=23000}
    writedsp($D1);
    initdma(blaster.lodma,play.p,size shl 1,false,true);
    setsamplingrate(play.data[datanum].frequency);
    if play.data[datanum].stereo then writemixer($0E,readmixer($0E) or $20);
    writedsp($48);
    writedsp(Lo(size-1));
    writedsp(Hi(size-1));
    writedsp($1C);
  end;
end;


function setdownsample(freq : word;stereo,sound16bit : boolean) : word;
var
  maxsr : word;
begin
  dsjump := 2;
  if sound16bit then dsjump := dsjump shl 1;

  if (stereo)and(not blaster.stereo) then begin
    dsjump := dsjump shl 1;
    if sound16bit then downsample := downsample16m
      else downsample := downsample8m;
  end else begin
    if sound16bit then downsample := downsample16
      else downsample := downsample8;
  end;

  if (stereo)and(blaster.stereo) then maxsr := blaster.stereofreq else
  maxsr := blaster.monofreq;
{!!  while (freq > maxsr) do
  begin
    freq := freq shr 1;
    dsjump := dsjump shl 1;
  end;}
  setdownsample := freq;
end;

procedure startplay(datanum : byte);
var
  size,freq : word;
  flags     : word;
begin
  if not play.stopped then exit;
  play.blocksize := buffersize shr 1;
  actfile := datanum;
  seek(play.data[datanum].f,play.data[datanum].fdatastart);
  freq := setdownsample(play.data[actfile].frequency,play.data[actfile].stereo,
  play.data[actfile].sound16bit);
  if play.data[datanum].fdatasize < buffersize then begin
    {$IFNDEF DPMI}silence(play.p^,buffersize);{$ELSE}
    silence(ptr(play.p and $FFFF,0)^,buffersize);
    {$ENDIF}
    play.data[datanum].fileremain := play.data[datanum].fdatasize;
    if play.data[datanum].fdatasize > play.blocksize then size := play.blocksize else
    size := play.data[datanum].fdatasize;

    {$IFNDEF DPMI}read(play.data[datanum].f,play.p,size,play.blocksize);{$ELSE}
    read(play.data[datanum].f,ptr(play.p and $FFFF,0),size,play.blocksize);
    {$ENDIF}
    if play.data[datanum].fdatasize > play.blocksize then
    {$IFNDEF DPMI}
    read(play.data[datanum].f,ptr(seg(play.p^),ofs(play.p^)+play.blocksize),play.data[datanum].fileremain,play.blocksize);
    {$ELSE}
    read(play.data[datanum].f,ptr(play.p and $FFFF,play.blocksize),play.data[datanum].fileremain,play.blocksize);
    {$ENDIF}
  end else begin
    play.data[datanum].fileremain := play.data[datanum].fdatasize;
    {$IFNDEF DPMI}
    read(play.data[datanum].f,play.p,play.blocksize,play.blocksize);
    read(play.data[datanum].f,ptr(seg(play.p^),ofs(play.p^)+play.blocksize),play.blocksize,play.blocksize);
    {$ELSE}
    read(play.data[datanum].f,ptr(play.p and $FFFF,0),play.blocksize,play.blocksize);
    read(play.data[datanum].f,ptr(play.p and $FFFF,play.blocksize),play.blocksize,play.blocksize);
    {$ENDIF}
  end;
  play.paused := false;
  play.callproc := soundplaycaller;
  if play.data[datanum].stereo then flags := snd_stereo else flags := snd_mono;
  if play.data[datanum].sound16bit then flags := flags or snd_16bit else
    flags := flags or snd_8bit;
  with play do
  initplay(datanum,p,blocksize shl 1,freq,flags);
end;

procedure stopplay;
begin
  if not play.stopped then begin
    exitplay;
    play.stopped := true;
  end;
end;


procedure setplaypos(datanum : byte;pos : longint);
begin
  seek(play.data[datanum].f,pos);
  play.data[actfile].fileremain := play.data[actfile].fsize-play.data[actfile].fdatastart-pos;
end;

function setmemsize(size : word) : boolean;
begin
  if (size <= 16107)and(size >= 500)and(play.stopped) then begin
    size := size and $FFFC; {must be divideable by four!}
    if dsbuf <> nil then freemem(dsbuf,buffersize*4);
    getmem(dsbuf,size*4);
    {$IFNDEF DPMI}
    if play.p <> nil then freemem(play.p,buffersize);
    buffersize := size;
    getmem(play.p,buffersize);
    {$ELSE}
    globaldosfree(play.p);
    buffersize := size;
    play.p := globaldosalloc(buffersize);
    {$ENDIF}
    setmemsize := true;
  end else setmemsize := false;
end;

var
  lastfilemode : byte;

function openvoc(datanum : byte;filename : string) : byte;
{I cannot garantuee that this here really works at all - this
 seems to be the most stupid file format I've ever seen!
 24 bits integers, time constants instead of Sampling frequencies,
 a lot of needless chunk types...}
type
  tvocheader = record
    kennstr    : array[0..$13] of char;
    datastart  : word;
    version    : word;
  end;

  tvocchunk = record
    blocktype  : byte;
    blocksize  : array[0..2] of byte; {really stupid! 24 bits integers!!!}
  end;

  tchunk1 = record     {preceded by chunktype 8 if any other attributes
                        otherwise the data is mono}
    timeconst  : byte; {really crappy way to save samplingrate...}
    packmethod : byte; {0:8bit; 1:4bit; 2:3bit;3:4bit}
  end;

  tchunk8 = record
    timeconst  : word;
    packmethod : byte;
    stereo     : boolean;
  end;

  tchunk9 = record
    frequency  : longint;
    resolution : byte;
    channels   : byte;
    format     : word; {0: 8bit unsigned;4:16bit signed}
    reserved   : array[0..3] of byte;
  end;

var
  vochdr    : tvocheader;
  chunk     : tvocchunk;
  chunk1    : tchunk1;
  chunk8    : tchunk8;
  chunk9    : tchunk9;
  blocksize : longint;

function checkchunks : boolean;
var
  i        : integer;
begin
  i := 0;
  checkchunks := false;
  {$I-}
  repeat
    blockread(play.data[datanum].f,chunk,sizeof(chunk));
    blocksize := longint(chunk.blocksize[2]) shl 16+
                 longint(chunk.blocksize[1]) shl 8+
                 longint(chunk.blocksize[0]);
    inc(i);
    case chunk.blocktype of
    1 : begin
          blockread(play.data[datanum].f,chunk1,sizeof(chunk1));
          play.data[datanum].stereo := false;
          play.data[datanum].sound16bit := false;
          play.data[datanum].frequency :=
          256000000 div (65536-(word(chunk1.timeconst) shl 8));
          play.data[datanum].fdatasize  := blocksize-sizeof(chunk1);
          if (chunk1.packmethod <> 0) then exit;{ no packing supported }
        end;
    8 : begin
          blockread(play.data[datanum].f,chunk8,sizeof(chunk8));
          play.data[datanum].stereo := chunk8.stereo;
          play.data[datanum].sound16bit := false;
          play.data[datanum].frequency :=
          256000000 div (65536-((word(chunk8.stereo)+1)*chunk8.timeconst));
          play.data[datanum].fdatasize  := blocksize-sizeof(chunk8);
          if (chunk8.packmethod <> 0) then exit;{ no packing supported }
        end;
    9 : begin
          blockread(play.data[datanum].f,chunk9,sizeof(chunk9));
          play.data[datanum].stereo     := boolean(chunk9.channels-1);
          case chunk9.format of
            0 : play.data[datanum].sound16bit := false;
            4 : play.data[datanum].sound16bit := true;
            else exit; { no packing supported }
          end;
          play.data[datanum].frequency  := chunk9.frequency;
          play.data[datanum].fdatasize  := blocksize-sizeof(chunk9);
        end;
    else seek(play.data[datanum].f,filepos(play.data[datanum].f)+blocksize)
    end;
  until ((chunk.blocktype = 1)or(chunk.blocktype = 8)or(chunk.blocktype = 9))and
  (blocksize > 12)or(eof(play.data[datanum].f))or(i >= 32);
  if i >= 32 then exit;
  if eof(play.data[datanum].f) then exit;
  {$I+}
  checkchunks := true;
end;

begin
  openvoc := sb_filenotfound;
  if not play.data[datanum].fclosed then closesound(datanum);
  if not blaster.available then begin
    openvoc := sb_nocardfound;
    exit;
  end;
  if datanum > 19 then begin
    openvoc := sb_nohandles;
    exit;
  end;

  assign(play.data[datanum].f,filename);
  lastfilemode := filemode;
  filemode := 64;
  {$I-}reset(play.data[datanum].f,1);{$I+}

  dummy := ioresult;
  filemode := lastfilemode;
  if (dummy <> 0)and(dummy <> 100) then exit;

  openvoc := sb_falseformat;
  blockread(play.data[datanum].f,vochdr,sizeof(vochdr));
  if vochdr.kennstr <> 'Creative Voice File'#26 then begin
    close(play.data[datanum].f);
    exit;
  end;
  seek(play.data[datanum].f,vochdr.datastart);
  if not checkchunks then exit;
  play.data[datanum].fdatastart := filepos(play.data[datanum].f);
  play.data[datanum].fsize      := filesize(play.data[datanum].f);

  play.data[datanum].fileremain := play.data[datanum].fdatasize;

  play.data[datanum].fclosed := false;
  openvoc      := sb_noerror;
end;



function openwav(datanum : byte;filename : string) : byte;
type
  twavehdr = record {Header of a wavefile}
    formatlength  : longint;
    formattag     : word;
    channels      : word;
    frequency     : longint;
    bytespersecnd : longint;
    blkalign      : word;
    resolution    : word;
  end;

  triff = record{20}
    riff      : array[0..3] of char;
    chunksize : longint;
    acon      : array[0..3] of char;
  end;

  tlist = record
    list : array[0..3] of char;
    size : longint;
  end;

var
  wavehdr  : twavehdr;
  h        : triff;
  l        : tlist;
  s        : string;
  oldpos   : longint;

function checkchunks : boolean;
var
  i        : integer;
begin
  i := 0;
  checkchunks := false;
  {$I-}
  blockread(play.data[datanum].f,h,sizeof(h));
  repeat
    blockread(play.data[datanum].f,l,sizeof(l));
    if l.list = 'fmt ' then begin
      oldpos := filepos(play.data[datanum].f);
      seek(play.data[datanum].f,oldpos-4);
      blockread(play.data[datanum].f,wavehdr,sizeof(wavehdr));
      seek(play.data[datanum].f,oldpos+l.size);
    end
    else if l.list <> 'data' then
    seek(play.data[datanum].f,filepos(play.data[datanum].f)+l.size);
    inc(i);
  until (l.list = 'data')or(eof(play.data[datanum].f))or(i >= 32);
  if i >= 32 then exit;
  if eof(play.data[datanum].f) then exit;
  {$I+}
  checkchunks := true;
end;

begin
  openwav := sb_filenotfound;
  if not play.data[datanum].fclosed then closesound(datanum);
  if not blaster.available then begin
    openwav := sb_nocardfound;
    exit;
  end;
  if datanum > 19 then begin
    openwav := sb_nohandles;
    exit;
  end;
  assign(play.data[datanum].f,filename);
  lastfilemode := filemode;
  filemode := 64;
  {$I-}reset(play.data[datanum].f,1);{$I+}
  dummy := ioresult;
  filemode := lastfilemode;
  if (dummy <> 0)and(dummy <> 100) then exit;
  if not checkchunks then begin
    openwav := sb_falseformat;
    exit;
  end;
  play.data[datanum].fdatastart := filepos(play.data[datanum].f);
  if wavehdr.formattag <> 1 then begin {compressed file or unknown sampletype}
    openwav := sb_nocompressed;
    exit;
  end;

  if (wavehdr.resolution <> 8)and(wavehdr.resolution <> 16) then begin
    close(play.data[datanum].f);
    openwav := sb_falseformat;
    exit;
  end;
  byte(play.data[datanum].sound16bit) := wavehdr.resolution div 16;
  play.data[datanum].signed           := play.data[datanum].sound16bit;
  byte(play.data[datanum].stereo)     := wavehdr.bytespersecnd div
  wavehdr.frequency div succ(byte(play.data[datanum].sound16bit))-1;
  play.data[datanum].frequency        := wavehdr.frequency;

  play.data[datanum].fsize := filesize(play.data[datanum].f);
  play.data[datanum].fdatasize := {wavehdr.chunklength}l.size;
  play.data[datanum].fileremain := play.data[datanum].fdatasize;

  play.data[datanum].fclosed := false;
  openwav                    := sb_noerror;
end;


function opensound(datanum : byte;s : string) : byte;
var
  i : byte;
begin
  for i := 1 to length(s) do s[i] := upcase(s[i]);
  if pos('.VOC',s) <> 0 then opensound := openvoc(datanum,s) else
  opensound := openwav(datanum,s);
end;

procedure closesound(datanum : byte);
begin
  if not blaster.available then exit;
  exitplay;
  {$I-}
  if not play.data[datanum].fclosed then close(play.data[datanum].f);
  {$I+}
  dummy := ioresult;
  play.data[datanum].fclosed := true;
end;

begin
  {$IFNDEF DPMI}
  getmem(play.p,buffersize);
  {$ELSE}
  globaldosfree(play.p);
  play.p := globaldosalloc(buffersize);
  {$ENDIF}
  getmem(dsbuf,buffersize*4);
  blaster.available        := false;
  oldexitproc              := ExitProc;
  exitproc                 := @exitblaster;
  play.callproc            := dummycaller;
  play.stopped             := true;
  for dummy := 0 to 19 do
  play.data[dummy].fclosed := true;
  rec.callproc             := dummycaller;
  rec.stopped              := true;
  rec.fclosed              := true;
  detectblaster            := detectblaster_norm;
end.
{
Filemodes
 0  Read only
 1  Write only
 2  Read/Write
 Deny_all =         $10;
 Deny_write =       $20;
 Deny_read =        $30;
 Deny_none =        $40;
 Inheritance_flag = $80;
}
